<template lang="pug">
BaseCard(key="opYearPeriodShiftPoints" tabIndex="-1").highlightOnFocus
  template(v-slot:header='')
    BaseAnimationBlock
      .d-flex(key='title')
        h5 Shift Points for #[span.text-muted {{ year }}]
        template(v-if="editable")
          .ml-auto.clickable(@click='setEdit(true)' v-if='!inEdit')
            kbd.keyHint.mr-2(v-if="showKeyHints") E
            i.fa.fa-cog
          .ml-auto.clickable(@click='setEdit(false)' v-if='inEdit')
            kbd.keyHint.mr-2(v-if="showKeyHints") Esc
            i.fa.fa-times
  li.p-0(key='shiftPointsCalendar').x-shift-points
    BaseModalLoader(:isLoading="loading")
    table.table.table-hover.text-center
      thead.bg-light.table-head
        tr
          th
          th Monday
          th Tuesday
          th Wednesday
          th Thursday
          th Friday
          th Saturday
          th Sunday
      tbody
        tr(v-if="showLeaderPoints")
          td.align-middle(title="Shift Leader: 00h - 24h")
            span.badge.bg-light.text-slot L
          td(v-for="(row, day) in getRowsByShiftType(ShiftKindType.LEADER)")
            BaseInput(v-if="editable" :ref="`${ShiftKindType.LEADER}-${day}`" v-model="row.value" :inEdit="inEdit" :noEditIcon="true"
              type="number" step="0.5" min="0" required @edit="onEdit($event, row)")
            span(v-else) {{ row.value }}
        tr
          td.align-middle(title="Night: 00h - 08h")
            span.badge.bg-light.text-slot N
          td(v-for="(row, day) in getRowsByShiftType(ShiftKindType.NIGHT)")
            BaseInput(v-if="editable" :ref="`${ShiftKindType.NIGHT}-${day}`" v-model="row.value" :inEdit="inEdit" :noEditIcon="true"
              type="number" step="0.5" min="0" required @edit="onEdit($event, row)")
            span(v-else) {{ row.value }}
        tr
          td.align-middle(title="Morning: 08h - 16h")
            span.badge.bg-light.text-slot M
          td(v-for="(row, day) in getRowsByShiftType(ShiftKindType.MORNING)")
            BaseInput(v-if="editable" :ref="`${ShiftKindType.MORNING}-${day}`" v-model="row.value" :inEdit="inEdit" :noEditIcon="true"
              type="number" step="0.5" min="0" required @edit="onEdit($event, row)")
            span(v-else) {{ row.value }}
        tr
          td.align-middle(title="Afternoon: 16h - 24h")
            span.badge.bg-light.text-slot A
          td(v-for="(row, day) in getRowsByShiftType(ShiftKindType.AFTERNOON)")
            BaseInput(v-if="editable" :ref="`${ShiftKindType.AFTERNOON}-${day}`" v-model="row.value" :inEdit="inEdit" :noEditIcon="true"
              type="number" step="0.5" min="0" required @edit="onEdit($event, row)")
            span(v-else) {{ row.value }}
  li(v-if='processing' key='processing')
    .row.justify-content-center
      i.align-bottom.fa.fa-spinner.fa-pulse
  li(v-if='!loading && inEdit && !processing' key='submit')
    .d-flex.justify-content-between
      .mx-1
        button.btn.btn-primary.x-copy-prev(@click="copyPreviousYear()")
          i.fa.fa-copy.mr-1
          | Copy Previous Year
      .mx-1.d-flex.justify-content-end
        .alert.alert-warning.m-0.p-1(v-if="dirtyValue")
          i.fa.fa-exclamation-triangle.mx-2.p-0
          | Remember to save!
        button.btn.btn-primary.mx-1.x-submit(@click="doSubmit()")
          kbd.keyHint.mr-2(v-if="showKeyHints") Ctrl+S
          i.fa.fa-upload.mr-1(v-else)
          | Submit
  template(v-slot:footer='')
    .d-flex.justify-content-between
      template(v-if="showLeaderPoints")
        span #[strong Total Points Per Week]: {{ totPointsPerWeek }}
        span #[strong Total Non Leader Points Per Week]: {{ totNonLeaderPointsPerWeek }}
      template(v-else)
        span #[strong Points Per Week]: {{ totNonLeaderPointsPerWeek }}
</template>
<script>

export { default } from './ShiftPoints.vue.js';

</script>

<style lang="scss">
.x-shift-points {

  .table th {
    vertical-align: middle;
    font-size: 0.9rem;
  }

  input {
    text-align: center;
  }

  .text-slot {
    font-size: 1.1rem;
    font-family: monospace;
    border: #4682B4 1px solid;
  }
}
</style>
